package org.openxma.dsl.generator.component;

import java.io.File;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tools.ant.util.FileUtils;
import org.eclipse.xpand2.output.FileHandle;
import org.eclipse.xpand2.output.VetoStrategy2;

/**
 * VetoStrategy to enable the conditional generation of concrete classes.
 */
public class ConditionalJavaGeneratorVetoStrategy implements VetoStrategy2 {
	protected final Log logger = LogFactory.getLog(getClass());
	private String checkPath;

	/**
	 * @param checkPath
	 *            the path where to check for concrete base classes
	 */
	public void setCheckPath(String checkPath) {
		this.checkPath = checkPath;
	}

	public boolean hasVetoBeforeOpen(FileHandle fileHandle) {
		try {
			String relativePath = FileUtils.getRelativePath(new File(fileHandle
					.getOutlet().getPath()), fileHandle.getTargetFile());
			boolean fileExists = new File(this.checkPath + File.separatorChar
					+ relativePath).exists();
			if (fileExists) {
				logger.warn("Skip generation of already existing java source '"
						+ fileHandle.getTargetFile() + "'");
			}
			return fileExists;
		} catch (Exception exception) {
			logger.error("Error while testing existing file", exception);
		}
		return false;
	}

	public boolean hasVeto(FileHandle handle) {
		return false;
	}
}
